<?php
 /*
 #########################################################################
 #                       xt:Commerce  4.1 Shopsoftware
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright 2007-2011 xt:Commerce International Ltd. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~ xt:Commerce  4.1 Shopsoftware IS NOT FREE SOFTWARE ~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @version $Id$
 # @copyright xt:Commerce International Ltd., www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce International Ltd., Kafkasou 9, Aglantzia, CY-2112 Nicosia
 #
 # office@xt-commerce.com
 #
 #########################################################################
 */

defined('_VALID_CALL') or die('Direct Access is not allowed.');
if (!class_exists('csv_pro_api', true))
	include_once _SRV_WEBROOT.'plugins/xt_pro_import/classes/class.csv_pro_api.php';

class xt_pro_import{

	protected $_table = TABLE_PROIMPORTPLUGIN;
	protected $_table_lang = null;
	protected $_table_seo = null;
	protected $_master_key = 'id';


	function setPosition ($position) {
		$this->position = $position;
	}

	function _getParams() {
		global $language;
	
		$header['id'] = array('type' => 'hidden');
	
		//$header['ei_filename'] = array('type' => 'dropdown','url'  => 'DropdownData.php?get=get_export_files');
		$header['ei_filename'] = array('type' => 'textfield');
	
	
		$header['ei_type'] = array('type' => 'dropdown',
				'url'  => 'DropdownData.php?get=pro_export_types&plugin_code=xt_pro_import');
	
		$header['ei_type_spec'] = array('type' => 'dropdown',
				'url'  => 'DropdownData.php?get=pro_export_typesspec&plugin_code=xt_pro_import');
	
		$header['ei_type_match'] = array('type' => 'dropdown',
				'url'  => 'DropdownData.php?get=pro_export_matching&plugin_code=xt_pro_import');
	
		$header['ei_type_match_2'] = array('type' => 'dropdown',
				'url'  => 'DropdownData.php?get=pro_export_matching_2&plugin_code=xt_pro_import');
	
		$header['ei_language'] = array('type' => 'status');
	
		$header['ei_price_type'] = array('type' => 'dropdown','url'  => 'DropdownData.php?get=conf_truefalse');
		
		$rowActions[] = array('iconCls' => 'start', 'qtipIndex' => 'qtip1', 'tooltip' => 'Run');
	
		if(!$this->url_data['edit_id'] && $this->url_data['new'] != true){
			$js = "var edit_id = record.data.ei_id;";
	
			$js .= "Ext.Msg.show({
			   title:'".TEXT_START."',
			   msg: '".TEXT_START_ASK."',
			   buttons: Ext.Msg.YESNO,
			   animEl: 'elId',
				 fn: function(btn) {if (btn == 'yes') {addTab('row_actions.php?type=api_csv_pro_export&seckey="._SYSTEM_SECURITY_KEY."&id='+edit_id,'... import / export ...');}},
			   icon: Ext.MessageBox.QUESTION
			});";
	
			$rowActionsFunctions['start'] = $js;
		}
	
		if(!$this->url_data['edit_id'] && $this->url_data['new'] != true){
			$js = "var edit_id = record.data.id;var ei_type_spec = record.data.ei_type_spec; var ei_type = record.data.ei_type;var ei_filename=record.data.ei_filename;";
			// TODO ml text
			$js .= "addTab('adminHandler.php?type=xt_pro_import_fields_mapping&plugin=xt_pro_import&load_section=xt_pro_import_fields_mapping";
			$js .= "&proimportplugin_id='+edit_id+'&ei_type_spec='+ei_type_spec+'&ei_type='+ei_type+'&ei_filename='+ei_filename,'Setup Fields Mapping')";
			
			$rowActions[] = array('iconCls' => 'settings', 'qtipIndex' => 'qtip1', 'tooltip' => 'Setup Fields Mapping');
			$rowActionsFunctions['settings'] = $js;
			
			$rowActions[] = array('iconCls' => 'cron_log', 'qtipIndex' => 'qtip1', 'tooltip' => TEXT_XT_IMPORT_EXPORT_LOG);
			$js = "var edit_id = record.data.ei_id;";
			$extF = new ExtFunctions();
			$js.= $extF->_RemoteWindow("TEXT_XT_IMPORT_EXPORT_LOG","TEXT_XT_IMPORT_EXPORT_LOG","adminHandler.php?plugin=xt_im_export&load_section=xt_im_export_log&pg=overview&ei_id='+edit_id+'", '', array(), 800, 600).' new_window.show();';
	
			$rowActionsFunctions['cron_log'] = $js;
		}
	
		$js = "";
	
		if (! $_GET['new']) {
			$params['rowActionsJavascript'] = $js;
	
			$params['rowActions']             = $rowActions;
			$params['rowActionsFunctions']    = $rowActionsFunctions;
		}
	
	
		if (!$this->url_data['edit_id'] && $this->url_data['new'] != true) {
			$params['include'] = array ('id','ei_id','ei_type','ei_type_spec','ei_title', 'ei_delimiter', 'ei_limit','ei_filename');
		}
	
		$params['header']         = $header;
		$params['master_key']     = $this->_master_key;
		$params['default_sort']   = $this->_master_key;
		$params['SortField']      = $this->_master_key;
		$params['SortDir']        = "DESC";
	
		/* grouping params */
		$params['GroupField']     = "ei_type";
		/* grouping params end */
	
		return $params;
	}
	
	function _get($ID = 0) {
		global $xtPlugin, $db, $language;

		if ($this->position != 'admin') return false;

		if ($ID === 'new') {
			$obj = $this->_set(array('ei_delimiter' => ';', 'ei_enclosure' => '"', 'ei_type_spec' => 'products'), 'new');
			$ID = $obj->new_id;
		}

		$table_data = new adminDB_DataRead($this->_table, $this->_table_lang, $this->_table_seo, $this->_master_key);

		if ($this->url_data['get_data'])
		$data = $table_data->getData();
		elseif($ID) {
			$data = $table_data->getData($ID);
			if ($data[0][ei_enclosure] == '&quot;') {
				$data[0][ei_enclosure] = '\"';
			}
		}
		else
		$data = $table_data->getHeader();


		$obj = new stdClass;
		$obj->totalCount = count($data);
		$obj->data = $data;

		return $obj;
	}

	function _set($data, $set_type='edit'){
		global $db,$language,$filter;


		if($data['ei_id']=='') {
			$data['ei_id'] = md5(rand(5, 15).time());
		}
		
		$deleteMapping = false;
		if (isset($data['id']) && !empty($data['id'])) {
			$editedObj = $this->_get($data['id']);
			
			// If type of export/import has changed delete old mapping to insert new field mapping for this type
			if (($editedObj->data[0]['ei_type_spec'] != $data['ei_type_spec']) || ($editedObj->data[0]['ei_type'] != $data['ei_type'])) {
				$deleteMapping = true;
			}
		}
		
		$obj = new stdClass;
		$o = new adminDB_DataSave($this->_table, $data, false, __CLASS__);
		$obj = $o->saveDataSet();
		
		$id = isset($obj->new_id) ? $obj->new_id : $data['id'];
		// Delete old mapping
		if ($deleteMapping) {
			$query = sprintf("DELETE FROM %s WHERE proimportplugin_id=%d", TABLE_PROIMPORTPLUGIN_FIELDS_MAPPING, $id);
			$db->Execute($query);
		}
		// If we save object for first time check if any mapped fields have been created for this type
		// If no create them
		$query = sprintf("SELECT * FROM %s WHERE proimportplugin_id=%d", TABLE_PROIMPORTPLUGIN_FIELDS_MAPPING, $id);
		$rs = $db->Execute($query);
		if ($rs->RecordCount() == 0) {
			switch ($data['ei_type']) {
				case 'export':
					$supporttedFields = csv_pro_api::getSupporttedFieldsForType($data['ei_type_spec']);
					if (!empty($supporttedFields)) {
						$sort = 0;
						foreach ($supporttedFields as $fieldName) {
							$insert_data = array(
								'proimportplugin_id' => $id,
								'store_field' => $fieldName,
								'csv_field' => 'No selection',
								'sort_order' => $sort,
							);
							$db->AutoExecute(TABLE_PROIMPORTPLUGIN_FIELDS_MAPPING, $insert_data, 'INSERT');
							$sort++;
						}
					}
					break;
				case "import":
				case "update":
					$file = _SRV_WEBROOT.'export/'.$data['ei_filename'];
					
					if (file_exists($file)) {
						$supporttedFields = csv_pro_api::getCsvColumns($file, $data['ei_delimiter'], $data['ei_enclosure']);
						
						if (!empty($supporttedFields)) {
							$sort = 0;
							foreach ($supporttedFields as $fieldName) {
								$insert_data = array(
										'proimportplugin_id' => $id,
										'store_field' => 'No selection',
										'csv_field' => $fieldName,
										'sort_order' => $sort,
								);
								$db->AutoExecute(TABLE_PROIMPORTPLUGIN_FIELDS_MAPPING, $insert_data, 'INSERT');
								$sort++;
							}
						}
					}
					break;
			}
		}
			
		return $obj;
	}


	function _unset($id = 0) {
		global $db;
		if ($id == 0) return false;
		if ($this->position != 'admin') return false;
		$id=(int)$id;
		if (!is_int($id)) return false;

		$db->Execute("DELETE FROM ". $this->_table ." WHERE ".$this->_master_key." = '".$id."'");
		$db->Execute("DELETE FROM ". TABLE_PROIMPORTPLUGIN_FIELDS_MAPPING . " WHERE proimportplugin_id='" . $id . "'");

	}


}
?>